/*3
    Exotic Pan Filter for VirtualDub.
	by Natan Never 2000 (NNever2000)
    
	I'm searched this filter for months on all internet sites. All pan filter
	that I found was near but not perfect for what I want.

	So I started coding it myself.

	Because I'm a C++ novice, this filter is based on the project files of
	Donald A. Graft's Zoom Filter (that was the first filter that I 
	compiled successfull). So, all credits goes to Donald Graft and Avery Lee 
	that are the authors of the original, astonishing, Zoom filter.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be contacted at:

	Natan Never 2000
	nnever2000@yahoo.it
	Wishes neartime
		ScrollBar next to rectangles should activate rectangle (enabling delete before or after movie segment)
		Scrollbar should command preview to that possition
	
	Wishes longer term
		sliding crosshair rectangle to aim offsets after
		Better border bleeding result (Combining a 2 or 3 pixels to the artificial one?)
		Merge code with zoom plugin to give variable zoom.
		Duplicate frames, giving a poor mans slow motion effect.
		"Debug mode" sould oly vork in preview, and maintain same output size (iow zoom out)

	2017.02.25  Bugfix from efactor in commit 63 (Hiding PanelPoint.height and common pp "constructor")
	2017.02.19  Bugfix way back from commit 60 (Hiding PanelPoint.iFrame by set/get methods)
	2017.02.16  Rename the "debug" to "Frame", redo the debug functionality to stay in same frame size by zooming out.
	2017.02.14  Remove the "Dont crop" capability
	2017.01.06  Hiding PanelPoint.height and common pp "constructor"
	2017.01.06  Hiding PanelPoint.iOffset_y by set/get methods
	2017.01.06  Hiding PanelPoint.iOffset_x by set/get methods
	2017.01.04  Hiding PanelPoint.iFrame by set/get methods
	2016.12.07  Added 540p button, added hook proc for keyboard input, move focus back to preview, modified RedoSystem to RedoFrame
	2016.08.08  Bugfix. Now loads definitions correctly
	2016.07.17  Release 1.2 = Mercurial ver 53. (released width a load bug, bugger)
	2016.07.13  Added 2 buttons. "Jump" which adds 2 rectangles to handle jump between scenes. & "Add N-1" copies last but one rectangel 
	2016.07.12  Fixup of central focus point to initially be centralized. also the "inside" button needed a fixup to work correctly. 
	2016.07.10  Dialog related methods moved to separate source file. 
	2016.05.28  Bugfix Persistance method changed data in order to persist, so a subsequent load was required
	2016.05.27  Internally use center position, so shift of resolution will show same "picture" with more or less "border" around..
	2016.05.22  Enabled border bleeding and removed code forcing dest rectangle to be completeley within source. Added "inside" reset button.
	2016.05.20  "Add" button dsabled when on top of a definition, Delete updates frame in preview and selects nearest rectangle in dialog.
	2016.03.26  Explicit typecasts in relation to below bug. Small improvement to frame nr display. Now as "x of y".
	2016.03.26  Bugfix. 1) Bubblesort had an error. 2) Load new format wa missing a zero termination.
	2015.12.12  Improving bubblesort so it's a wee bit more generic, in prep for CorssHair.
	2015.11.01  Increased number of rectangles to 100. Minor changes to handle rectangle going outside source frame. Bugfix in locatePanelPointOnOrBeforeFrame. Removed ChkMark on each rectangled. Introduced delete buttn. Added move buttons to adjust current rectangle.
	2015.10.06  Removed 7 of 10 rows of fields. Made the active row scroll together with preview slider. Added a slider for manual row selection, thoug not functional yet.
	2015.10.03  Added new storage format to acommodate dynamic sections cunt.
	2015.10.03  Added a "new" button, that would put current offset and frame into last cell_set and do a  repaint..
	2015.07.07  Display current frame in dialog.
	2014.06.04	Bugfix:Save/Load now called properly so that works
				Lifting a 1024 size limit to 3840 (uhd = 1920x2)
				Mod:Max size limit raised, enabling e.g 1280x720 resolution
				Mod:Adding buttons for standard resolutions.
				Mod:Debug frame drawn with triple pixel frame, assuring visibility also down to 33%
	2015.05.14	Sorting often happened behind covers even if dialog was open. Fixed that and opdated dialog.
				Field value first checked on leave. Gives nicer edit UI.
				Big amount of code duplication reduced (in window message loop method).
	2015.06.28  Bugfix. Buttons setting default sizes stopped working when "field exit" handling were introduced.
*/

#define VDEXT_VIDEO_FILTER
#define VDEXT_MAIN
#define VERSIONINFO "1.2.07" //AoS(74)" //Array of structure branch
#define BUILDDATE "2017-02-25"
#define VERS_BUILD BUILDDATE " " VERSIONINFO
#define PERSISTANCE_FORMAT 0  //0: Format with top left corner values  1:format width center values
#include <windows.h>
#include <commctrl.h>
#include <crtdbg.h>
#include <assert.h>
#include <stdio.h>
#include <math.h>

#include "ScriptInterpreter.h"
#include "ScriptValue.h"
#include "ScriptError.h"

#include "resource.h"
#include "filter.h"
#include "InterModuleDef.h"

///////////////////////
int getFrame(PanelPoint pp[], int idx) {	return pp[idx].iFrame; }
int getFrame(MyFilterData * mfd, int idx) { return getFrame(mfd->pp, idx); }
void setFrame(MyFilterData * mfd, int idx, int value) {	mfd->pp[idx].iFrame=value;}

int getOfsX(PanelPoint* pp) { 	return pp->iOffset_x;}
int getOfsX(PanelPoint pp[], int idx) {	return getOfsX(&pp[idx]); }
int getOfsX(MyFilterData * mfd, int idx) { return getOfsX(mfd->pp, idx); }
void setOfsX(MyFilterData * mfd, int idx, int value) {	setOfsX(&(mfd->pp[idx]), value);}
void setOfsX(PanelPoint* pp, int value) {	pp->iOffset_x=value;}

int getOfsY(PanelPoint* pp) { 	return pp->iOffset_y;}
int getOfsY(MyFilterData * mfd, int idx) { return mfd->pp[idx].iOffset_y; }
void setOfsY(MyFilterData * mfd, int idx, int value) {	mfd->pp[idx].iOffset_y = value;}
void setOfsY(PanelPoint* pp, int value) {	pp->iOffset_y=value;}

int getHeight(MyFilterData * mfd, int idx) { return mfd->pp[idx].iHeight; }
void setHeight(MyFilterData * mfd, int idx, int value) {	mfd->pp[idx].iHeight = value;}

void setPP(PanelPoint* pp, int frame, int ofsX, int ofsY, int height) {
	pp->iFrame=frame; pp->iOffset_x=ofsX; pp->iOffset_y=ofsY; pp->iHeight = height; pp->fEnabled= true;}

void setPP(MyFilterData * mfd, int idx, int frame, int ofsX, int ofsY, int height) { 
	setPP(&(mfd->pp[idx]), frame, ofsX, ofsY, height); }
	

void swapFrames(PanelPoint pp[], int a, int b) {
				int iFrame_swap= pp[a].iFrame;
				pp[a].iFrame= pp[b].iFrame;
				pp[b].iFrame= iFrame_swap;

				int iOffset_x_swap= pp[a].iOffset_x;
				pp[a].iOffset_x= pp[b].iOffset_x;
				pp[b].iOffset_x=iOffset_x_swap;

				int iOffset_y_swap= pp[a].iOffset_y;
				pp[a].iOffset_y= pp[b].iOffset_y;
				pp[b].iOffset_y= iOffset_y_swap;
					
				bool fEnabled_swap= pp[a].fEnabled;
				pp[a].fEnabled= pp[b].fEnabled;
				pp[b].fEnabled= fEnabled_swap;			
}
///////////////////////

int locatePanelPointOnOrBeforeFrame(MyFilterData *mfd, int frame, int seed) {
	if (frame <= getFrame(mfd, 0))	return -1; //Before first
	else if (frame >= getFrame(mfd, mfd->iIntervals-1)) return mfd->iIntervals; //after last
	else for (int i = 1; i < mfd->iIntervals; i++) {
		if (getFrame(mfd, i) >= frame) return i-1;
	}
	return mfd->iIntervals-1; //Should not hit this
}
int locatePanelPointClosestTOFrame(MyFilterData *mfd, int frame, int seed) {
	int i= locatePanelPointOnOrBeforeFrame(mfd, frame, seed);
	if (i<0) return 0;                                  //No need to calculate delta if before 1st fram
	if (i> mfd->iIntervals-1) return mfd->iIntervals-1; //No need to calculate delta if on or after last frame

	int delta1, delta2;
	delta1 = frame - getFrame(mfd, i);
	delta2 = getFrame(mfd, i+1) - frame;
	if (delta1>delta2) i++; //smallest delta wins
	return i;
}

void postMessageIfClosestPanelChanges(MyFilterData *mfd, int frame) {
	int ppctfi = locatePanelPointClosestTOFrame(mfd, frame, mfd->PanelPointClosestToFrameIn);
	if (ppctfi!=mfd->PanelPointClosestToFrameIn) { //
		mfd->PanelPointClosestToFrameIn = ppctfi;
		if (mfd->hDlg != 0) {
			PostMessage(mfd->hDlg, WM_USER + WM_USER_UPDATE_FOCUSED_PP, 0, 0); //inform DLG on frame numbers have changed.
		}
	}
}

void drawLine(const FilterActivation *fa, int x, int dx, int y, int dy, unsigned long color) {
	int i; 	Pixel *dst;
	if (dx<0) {x+=dx; dx=-dx;}
	if (dy<0) {y+=dy; dy=-dy;}
	if (dy==0) {
		if (y>0 && y<fa->dst.h) {
			dst	= (Pixel *)((char *)fa->dst.data + (fa->dst.pitch)*(fa->dst.h-y));
			if (x+dx>fa->dst.w) {dx = fa->dst.w - x;}  
			if (x<0) {dx+= x; x=0;} 
			for (i=0; i<dx; i++) {
			  dst[x+i] = color;
			}
		}
	} else if (dx==0) {
		for (i=0; i<dy; i++) {
			if (y+i>0 && y+i<fa->dst.h && x>0 && x<fa->dst.w) {
				dst	= (Pixel *)((char *)fa->dst.data + (fa->dst.pitch)*(fa->dst.h-y-i));
				dst[x] = color;
			}
		}
	} else {
		//Non horisontal or vertial lines not yet supported
		i = 7;
	}
}

int resize_run(const FilterActivation *fa, const FilterFunctions *ff) {
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;

	// Get source frame number
	int frame = (int) fa->pfsi->lCurrentFrame;
	int focusx, focusy, focush;

	// find the interval
	if (frame <= getFrame(mfd, 0))
	{
		focusx = getOfsX(mfd, 0);
		focusy = getOfsY(mfd, 0);
		focush = getHeight(mfd, 0);
	}
	else if (frame >= getFrame(mfd, mfd->iIntervals-1))
	{
		focusx = getOfsX(mfd, mfd->iIntervals-1);
		focusy = getOfsY(mfd, mfd->iIntervals-1);
		focush = getHeight(mfd, mfd->iIntervals-1);
	}
	else
	{
		focusx = 0;
		focusy = 0;
		focush = 0;

		for (int i = 0; i < mfd->iIntervals-1; i++)
		{
			if (frame >= getFrame(mfd, i) && frame<getFrame(mfd, i+1)) //If by chance we have 2 frames with same iFrame.
			{
				int start, end, startfocusx, endfocusx, startfocusy, endfocusy, startfocush, endfocush;
				start = getFrame(mfd, i);
				end = getFrame(mfd, i+1);
				startfocusx = getOfsX(mfd, i);
				endfocusx = getOfsX(mfd, i+1);
				startfocusy = getOfsY(mfd, i);
				endfocusy = getOfsY(mfd, i+1);
				startfocush =  getHeight(mfd, i);
				endfocush =  getHeight(mfd, i+1);
				
				focusx = startfocusx + ((endfocusx-startfocusx) * (frame-start)) / (end-start);
				focusy = startfocusy + ((endfocusy-startfocusy) * (frame-start)) / (end-start);
				focush = startfocush + ((endfocush-startfocush) * (frame-start)) / (end-start);

			}
		}
	}

	//this is used when "new" is pressed :-)
	mfd->FocusX = focusx;
	mfd->FocusY = focusy;
	mfd->FocusH = focush;
	mfd->FrameIn = fa->pfsi->lCurrentSourceFrame;
	mfd->FrameOut = fa->pfsi->lCurrentFrame;
	if (mfd->hDlg != 0) {
		PostMessage(mfd->hDlg, WM_USER + WM_USER_UPDATE_FRAME_NO, 0, 0); //inform DLG on frame numbers have changed.
	}
	postMessageIfClosestPanelChanges(mfd, frame);

	//double percent;
	Pixel *dst, *pSrc;
	unsigned long color;	

	/* Paint the destination frame with the color fill. */
	dst = fa->dst.data;
	color = (mfd->red << 16) | (mfd->green << 8) | mfd->blue;
	for (int y = 0; y < fa->dst.h; y++)
	{
		for (int x = 0; x < fa->dst.w; x++)
			dst[x] = color;
		dst	= (Pixel *)((char *)dst + fa->dst.pitch);
	}

	
	//Adjust from ceter to top left corner.
	focusx = focusx - mfd->new_x/2;
	focusy = focusy - mfd->new_y/2;

	// Begin rendering source -> filter -> destination
	// Calcolate the box
	int x_position = focusx;
	int y_position = fa->src.h-focusy-1;
	int w_position = focusx + mfd->new_x - 1;
	int h_position = fa->src.h-(focusy + mfd->new_y);

	{
		if (!mfd->fDebug) 
		{
			dst = fa->dst.data;

			for (int y = 0; y < fa->dst.h; y++)
			{
				int srcRow = y + fa->src.h-focusy-fa->dst.h;
				//To duplicate first and last row, if frame is outside
				if (srcRow<0) 
					srcRow = 0;
				if (srcRow >= fa->src.h) 
					srcRow = fa->src.h - 1;
				pSrc = (Pixel *)((char *)fa->src.data + fa->src.pitch * (srcRow)); //prefer to calc src pointer each time
				for (int x = 0; x < fa->dst.w; x++)
				{
					int srcCol = x + x_position;
					if (srcCol<0) 
						srcCol = 0;
					if (srcCol >= fa->src.w) 
						srcCol = fa->src.w - 1;
					try	{
						dst[x] = pSrc[srcCol];
					} catch(...) {  //probably the source location is out of bounds
						dst[x] = color;
					}
				}
				dst	= (Pixel *)((char *)dst + fa->dst.pitch);
			}
		}
		else
		{
			// DEBUG MODE, 
			// Zoom out and Paint the source in destination pixels and sourrond the cotout with a color frame
			// In debug mode, dst.w = src.w and dst.h=src.h
			bool UseNewCode = TRUE;
			pSrc = (Pixel *)((char *)fa->src.data);
			for (int y = 0; y < fa->dst.h; y++) {
				int srcRow = (y * fa->src.h) / fa->dst.h ; // + fa->src.h-focusy-fa->dst.h;
				pSrc = (Pixel *)((char *)fa->src.data + fa->src.pitch * (srcRow)); //prefer to calc src pointer each time
				dst	= (Pixel *)((char *)fa->dst.data + (fa->dst.pitch)*(y));
					for (int x = 0; x < fa->dst.w; x++)	{ 
					dst[x] = pSrc[(x * fa->src.w) / fa->dst.w];
				}
			}
			int y = (focusy * fa->dst.h) / fa->src.h ;
			int dy = (fa->dst.h * fa->dst.h) / fa->src.h;
			int x = (focusx * fa->dst.w) / fa->src.w;
			int dx = (fa->dst.w * fa->dst.w) / fa->src.w;

			drawLine(fa, x, dx, y, 0, color);
			drawLine(fa, x, dx, y+dy, 0, color);
			drawLine(fa, x, 0, y, dy, color);
			drawLine(fa, x+dx, 0, y, dy, color);
		}
	}
	return 0;
}

bool bubbleSortIntervals(struct PanelPoint pp[], int &iIntervals, int INTERVALS, bool bChangedAnything) {
	// Sort intervals
	for (int loopA = 0; loopA < INTERVALS -1; loopA	++)
	{
		for (int loopB = loopA + 1; loopB < INTERVALS; loopB++)
		{
			if ((pp[loopB].fEnabled==true) &&  //Sort those that are enabled to top and in sequence 
				(((pp[loopA].fEnabled==true) && (getFrame(pp, loopA) > getFrame(pp, loopB)))
				||
				(pp[loopA].fEnabled==false)
				))
			{
				bChangedAnything = true;
				swapFrames(pp, loopA, loopB);
			}				
		}			
	}
	if (bChangedAnything || iIntervals==0) {  //When loading a properly sorted array, we need to count them.
		// Count intervals
		iIntervals=0;
		for (int i = 0; i < INTERVALS; i++)
		{
			if (pp[i].fEnabled) iIntervals++; else break;
		}

		// There will be at least one interval
		if (iIntervals==0)
		{
			pp[0].fEnabled=true;
			iIntervals=1;
		}
	}
	return bChangedAnything;
}

bool bubbleSortIntervals(struct PanelPoint pp[], int &iIntervals, int INTERVALS) {
	return bubbleSortIntervals(pp, iIntervals, INTERVALS, false);
}

//Called right after init, when src dimentions are valid. (And realy many times after that)
long resize_param(FilterActivation *fa, const FilterFunctions *ff) {
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;

	if (!mfd) return 0;
	if (0==mfd->iIntervals) {
		mfd->pp[0].fEnabled = true;
		setFrame(mfd, 0, 0);
		setOfsX(mfd, 0, fa->src.w/2); 
		setOfsY(mfd, 0, fa->src.h/2);
		mfd->iIntervals = 1;
	}
	bubbleSortIntervals(mfd->pp, mfd->iIntervals, INTERVALS);  //Load now adjusts iIntervals, but just to be on the safe side.
	fa->dst.w = mfd->new_x;
	fa->dst.h = mfd->new_y;
	fa->dst.AlignTo8();

	//Update destination data to MyFilerData
	mfd->src_h = fa->src.h;
	mfd->src_w = fa->src.w;

	return FILTERPARAM_SWAP_BUFFERS;
}

static int resize_config(FilterActivation *fa, const FilterFunctions *ff, HWND hWnd) {
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;
	MyFilterData mfd2 = *mfd;
	long  ret;

	mfd->ifp = fa->ifp;

	if (mfd->new_x < 16)
		mfd->new_x = 320;
	if (mfd->new_y < 16)
		mfd->new_y = 240;

	ret = DialogBoxParam(fa->filter->module->hInstModule, MAKEINTRESOURCE(IDD_FILTER_ZOOM),
						 hWnd, resizeDlgProc, (LONG)mfd);

	if (ret)
		*mfd = mfd2;

	return ret;
}

//Build a string to present int the list of active filters.
static void resize_string(const FilterActivation *fa, const FilterFunctions *ff, char *buf) {
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;
	char bufstring[256]="";
	if (mfd->fDebug) 
		strcat_s(bufstring, "Debug mode");
	else
		strcat_s(bufstring, "Normal mode");

	strcat_s(bufstring, " ");
	strcat_s(bufstring, VERSIONINFO);
	wsprintf(buf, " (%s)", bufstring);
}

static int resize_start(FilterActivation *fa, const FilterFunctions *ff) {
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;
/*	double dstw = (mfd->startpercent * fa->src.w) / 100.0;
	double dsth = (mfd->startpercent * fa->src.h) / 100.0;

	if (mfd->new_x > fa->src.w || mfd->new_y > fa->src.h)
	{
		MessageBox(NULL,
			"Dimensions of the output frame cannot exceed those of "
			"the input frame. Please correct this and try again."
			,
			"Invalid output window size parameter",
			MB_ICONEXCLAMATION);
		return 1;
	}
	if (mfd->end < mfd->start)
	{
		MessageBox(NULL,
			"The specified ending frame cannot be before the specified "
			"starting frame. Please correct this and try again."
			,
			"Invalid ending frame parameter",
			MB_ICONEXCLAMATION);
		return 1;
	}
	if (mfd->startpercent2 != 0 && mfd->start2 < mfd->end)
	{
		MessageBox(NULL,
			"The specified phase 2 starting frame cannot be before the "
			"specified phase 1 ending frame. Please correct this and try again."
			,
			"Invalid starting frame parameter",
			MB_ICONEXCLAMATION);
		return 1;
	}
	if (mfd->startpercent2 != 0 && mfd->end2 < mfd->start2)
	{
		MessageBox(NULL,
			"The specified phase 2 ending frame cannot be before the "
			"specified phase 2 starting frame. Please correct this and try again."
			,
			"Invalid ending frame parameter",
			MB_ICONEXCLAMATION);
		return 1;
	}
	if (mfd->startfocusx > fa->src.w - 1 || mfd->startfocusy > fa->src.h - 1)
	{
		MessageBox(NULL,
			"The focus point must be within the dimensions of "
			"the input frame. Please correct this and try again."
			,
			"Invalid focus parameter",
			MB_ICONEXCLAMATION);
		return 1;
	}
	if (dstw<16 || dsth<16)
	{
		MessageBox(NULL,
			"The resampler requires the scaled output area to be at least "
			"16 x 16 pixels. Please correct this and try again."
			,
			"Invalid resampler configuration",
			MB_ICONEXCLAMATION);
		return 1;
	}

	switch(mfd->filter_mode) {
	case FILTER_NONE:			mfd->fmode = Resampler::eFilter::kPoint; break;
	case FILTER_BILINEAR:		mfd->fmode = Resampler::eFilter::kLinearInterp; break;
	case FILTER_BICUBIC:		mfd->fmode = Resampler::eFilter::kCubicInterp; break;
	case FILTER_TABLEBILINEAR:	mfd->fmode = Resampler::eFilter::kLinearDecimate; break;
	case FILTER_TABLEBICUBIC:	mfd->fmode = Resampler::eFilter::kCubicDecimate; break;
	}

	mfd->resampler = new Resampler();

	mfd->resampler->Init(mfd->fmode, mfd->fmode, dstw, dsth, fa->src.w, fa->src.h);*/

	return 0;
}

static int resize_stop(FilterActivation *fa, const FilterFunctions *ff) {
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;

//	delete mfd->resampler;	mfd->resampler = NULL;

	return 0;
}
/*****************  Utility functions   *****************************************************/
static int GetThumbPos(HWND hDlg, int ID_Ctl) {
	SCROLLINFO si;
	ZeroMemory(&si, sizeof(si));
	si.cbSize = sizeof(si);
	si.fMask = SIF_TRACKPOS;
	HWND sbar = GetDlgItem(hDlg, ID_Ctl);
	if (GetScrollInfo(sbar, SB_CTL, &si)) {  //SB_CTL SB_HORZ SB_VERT
		return si.nPos;
	} else {
		return -1;
	}
}

static int getDelimitedIntFromString(char * Str, char Delim, int StrIdx)
{
	char *pLeft, *pRight = Str-1; int strIdx=0;
	do {
		pLeft = pRight + 1;
		pRight = strchr(pLeft,Delim);
		if (NULL == pRight) pRight = pLeft + strlen(pLeft);
		if (pLeft == pRight) return MININT; //Not sufficient fields
		strIdx++;
		if (strIdx>StrIdx) { //Found the sourght field
			char num[20];
			num[0] = '\0'; 
			strncat(num, pLeft, pRight-pLeft); //strncpy_s(num, pLeft, pRight-pLeft);
			return atoi(num);
		}
	} while (TRUE);
}
/*****************  Persistance Section *****************************************************/
static void resize_script_save(IScriptInterpreter *isi, void *lpVoid, CScriptValue *argv, int argc)
{
	FilterActivation *fa = (FilterActivation *)lpVoid;

	MyFilterData *mfd = (MyFilterData *)fa->filter_data;

	//Original format, always 10 elements
	mfd->new_x			= argv[0].asInt();
	mfd->new_y			= argv[1].asInt();
	mfd->red			= argv[42].asInt();
	mfd->green			= argv[43].asInt();
	mfd->blue			= argv[44].asInt();
//	mfd->fDebug			= argv[45].asInt()>0;  //No need to store/reload debug  

	int j = 0;
	for (int i = 0; i <10-1; i++)
	{
		//mfd->pp[i].fEnabled		= argv[i*4+5].asInt()>0
		if (argv[i*4+5].asInt()>0) {
			setPP(mfd, j, argv[i*4+4].asInt(), argv[i*4+2].asInt(), argv[i*4+3].asInt(), 0);
			j++;
		}
	}
}


//read the new dynamic format.
static void resize_load_script(IScriptInterpreter *isi, void *lpVoid, CScriptValue *argv, int argc)
{
	FilterActivation *fa = (FilterActivation *)lpVoid;
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;
	int iPersistFormat;
	//Original format, always 10 elements
	mfd->new_x			= argv[0].asInt();
	mfd->new_y			= argv[1].asInt();
	mfd->red			= argv[2].asInt();
	mfd->green			= argv[3].asInt();
	mfd->blue			= argv[4].asInt();
	iPersistFormat		= (int) argv[5].asInt()/ 2;

	char *pStr= *(argv[6].asString());
	char str[20]="";
	int i = 0, l = 0;
	l = (int)(strchr(pStr,',') - pStr);
	while (l>0) {
		strncpy(str, pStr, l); 
		str[l] = '\0';

		int x = getDelimitedIntFromString(str, '.', 0);
		int y = getDelimitedIntFromString(str, '.', 1);
		if (iPersistFormat == 0) {
			//Convert left/top to center definitions
			x = x + mfd->new_x/2;
			y = y + mfd->new_y/2;
		}
		int height = getDelimitedIntFromString(str, '.', 2);
		int frame = getDelimitedIntFromString(str, '.', 3);
		setPP(mfd, i, frame, x, y, height);

		i++;
		pStr += l+1;
		l = (int)(strchr(pStr,',') - pStr);
		mfd->iIntervals = i;
	}
}


static ScriptFunctionDef resize_func_defs[]={
	{ (ScriptFunctionPtr)resize_script_save, "Config", "0iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii" },   
	{ (ScriptFunctionPtr)resize_load_script, NULL, "0iiiiiis" }, //new "dynamic" method   
	{ NULL },
};

static CScriptObject resize_obj={
	NULL, resize_func_defs
};

static bool resize_save_settings_line(FilterActivation *fa, const FilterFunctions *ff, char *buf, int buflen)
{
	#define eos(s) ((s)+strlen(s))
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;
	
	//char str[1000]="";
	_snprintf(eos(buf), buflen,  "Config(%d,%d,%d,%d,%d,%d,\"",mfd->new_x, mfd->new_y, mfd->red, mfd->green, mfd->blue, /*mfd->fDebug +*/ PERSISTANCE_FORMAT * 2); //Fileversion 1 shifted one bit
	int i=0;
	while (i<mfd->iIntervals && mfd->pp[i].fEnabled) {
		if (PERSISTANCE_FORMAT == 0) {
			//Convert center to left/top definitions
			//mfd->pp[i].iOffset_x = mfd->pp[i].iOffset_x - mfd->new_x/2;  //Not a good idea, destroys data for subsequent use if doing a saving inbetween.
			//mfd->pp[i].iOffset_y = mfd->pp[i].iOffset_y - mfd->new_y/2;
			_snprintf(eos(buf), buflen - strlen(buf), "%d.%d.%d.%d,", getOfsX(mfd, i) - mfd->new_x/2,  getOfsY(mfd, i) - mfd->new_y/2, getHeight(mfd, i), getFrame(mfd, i)); //"," as rec separator. "." as field separator x.y.f 
		} else {
			_snprintf(eos(buf), buflen - strlen(buf), "%d.%d.%d.%d,", getOfsX(mfd, i),  getOfsY(mfd, i), mfd->pp[i].iHeight, getFrame(mfd, i)); //"," as rec separator. "." as field separator x.y.f 
		}
		i++;
	}
	_snprintf(eos(buf), buflen - strlen(buf), "\")");

	return true;
}

int resize_init(FilterActivation *fa, const FilterFunctions *ff);

FilterDefinition filterDef_resize={
	0,0,NULL,
	"Exotic Pan (1.2)",
	"Exotic Pan (based on Zoom 1.2 by Donald Graft and internal resize filter by Avery Lee)."
#ifdef USE_ASM
			"\n[Assembly optimized] [FPU optimized] [MMX optimized]"
#endif
			,
	VERS_BUILD,
	NULL,
	sizeof(MyFilterData),
	resize_init,
	NULL,
	resize_run,
	resize_param,
	resize_config,
	resize_string,
	resize_start,
	resize_stop,

	&resize_obj,
	resize_save_settings_line,
};

extern "C" int __declspec(dllexport) __cdecl VirtualdubFilterModuleInit2(FilterModule *fm, const FilterFunctions *ff, int& vdfd_ver, int& vdfd_compat);
extern "C" void __declspec(dllexport) __cdecl VirtualdubFilterModuleDeinit(FilterModule *fm, const FilterFunctions *ff);

static FilterDefinition *fd_tutorial;

int __declspec(dllexport) __cdecl VirtualdubFilterModuleInit2(FilterModule *fm, const FilterFunctions *ff, int& vdfd_ver, int& vdfd_compat) {
	if (!(fd_tutorial = ff->addFilter(fm, &filterDef_resize, sizeof(FilterDefinition))))
		return 1;

	vdfd_ver = VIRTUALDUB_FILTERDEF_VERSION;
	vdfd_compat = VIRTUALDUB_FILTERDEF_COMPATIBLE;

	return 0;
}

void __declspec(dllexport) __cdecl VirtualdubFilterModuleDeinit(FilterModule *fm, const FilterFunctions *ff) {
	ff->removeFilter(fd_tutorial);
}

int resize_init(FilterActivation *fa, const FilterFunctions *ff) {
	MyFilterData *mfd = (MyFilterData *)fa->filter_data;

	INITIALIZE_VTBLS;
	mfd->new_x = 320;
	mfd->new_y = 240;
	for (int x = 0; x < INTERVALS -1; x++) {
		setOfsX(mfd, x, 0);
		setOfsY(mfd, x, 0);
		setFrame(mfd, x, 0);
		mfd->pp[x].fEnabled  = false;
	}

	mfd->iIntervals = 0;
	mfd->red = 255;
	mfd->green = 0;
	mfd->blue = 0;
	mfd->fDebug = false;
	mfd->hDlg = 0;
	return 0;
}
